import tkinter as tk

icomove = '''
iVBORw0KGgoAAAANSUhEUgAAACAAAAAgCAMAAABEpIrGAAABMlBMVEX///8AAAAAAAAAAAAAAAAAAAA
AAAAAAAAAAABDRUUAAABNUU9fYmJjZmVaXlxnbGpqbmu4vL3b3d7Cw8PP0NCNkI2OkJCSlpSZm5uZnJ
qgoaGlpqapqamqq6urq6utra2urq6vr6+wsLCysrK2tra5ubm6vr+7u7vBwcHCwsLDxMPIyMjLy8vNz
c3Ozs7P0NDW1tbY2Njb29vb3d7c3Nvh4eHi4uLj4+Pk5OTl5eXn6Ojo6enp6enp6urp6uvq6+vr6+vr
7Ozs7Ozs7e3t7e3t7u7u7u7u7+/u8PHv7+/v8PDw8PDw8fHx8fHx8fLx8vLy8vLy8/Pz8/Pz9PT09PT
09fX19fX19vb29vb29/f39/f3+Pj4+Pj5+fj5+fn6+vn6+vr6+/v7+/v8/Pz9/f3+/v4I2c3KAAAAFX
RSTlMAAQIDJTtFS0x4gZKYpq62xPf6/v7RkfSJAAABnUlEQVR42o2Tg4IjQRBA17vJ2Q7PVmxb45moB
/n/X7iurvGcahG8l64XHf17zi6vonN55gmX2nS+4nhBFCVJVlRVgzEufcK0XKm32p3eYDSeTGezBcza
J1wtao0Ww9PZYrlacRzHc5srn8AxDhg2CaJEZxf3Uq74Vrc/mkwpplBWFNqhkqSXciV04eFLwApN3MA
Yz72UK4nyxYoXJAXobrcjhJgvnBQQGBdlVaOU4JgJTGGCAlxSHGzAWElMYYI2s7lDDZMKmILCkheRA8
Ox0pjChDUnyD5uwRzSFDvCRpBU5IhRwBQU6AKbA8LJsBQUdhIs8HG4yGIKCs4BDFsGkQRJz+ImW8ADm
GDuRtVivvDjlV/QNu4Bptb8+vHD5y9PDVaCAmEb8ADSfnuwSOmxaadcMmGNG+CAZf6ltS8+Mp0UFCAB
Nxjt79lt7oHlpNy9CAmk+u3Nz4eWk3L/+ikVLgPCp/dPTDflxskRCKb3EhnD18+8lFsn/i9OPJ1KpzO
Zd17K7eMj30RTbvp5NOXeNT+PptyJ/eM7fH703/MLSVTu/2Cp7PcAAAAASUVORK5CYII=
'''

class DragWin(tk.Toplevel):
    def __init__(self, parent: callable, *args, **kwargs):
        super().__init__(parent, *args, **kwargs)
        self.overrideredirect(True)
        self.lift()
        self.wm_attributes('-topmost', True)
        #self.wm_attributes('-alpha', 0.3)
        self.ico = tk.PhotoImage(data=icomove)
        lbl = tk.Label(self, image=self.ico, bg='white')
        lbl.grid(row=0, column=0)

class DragEntry(tk.Entry):
    def __init__(self, parent: callable, *args, **kwargs):
        super().__init__(parent, *args, **kwargs)
        self.parent = parent
        self.dragable = True
        self.active = False
        self.mwin = None
        self.bind("<Button-3>", self._on_press)
        self.bind("<B3-Motion>", self._on_motion)
        self.bind("<ButtonRelease-3>", self._on_release)

    def _on_press(self, evt):
        if not self.active: return
        x,y = self.parent.winfo_pointerxy()
        #y = self.parent.winfo_pointery()
        self.mwin = DragWin(self.parent)
        self.mwin.geometry(f'+{x}+{y}')
        
    def _on_motion(self, evt):
        if not self.active: return
        x, y = self.parent.winfo_pointerxy()
        y = self.parent.winfo_pointery()
        self.mwin.geometry(f'+{x}+{y}')

    def _on_release(self, evt):
        if not self.active: return
        self.mwin.destroy()
        self.mwin = None
        x = self.parent.winfo_pointerx()
        y = self.parent.winfo_pointery()
        obj = self.__verify_to_coords((x,y))
        if obj and hasattr(obj, 'dragable'):
            txt = self.get()
            obj.insert(tk.END, txt)

    def __verify_to_coords(self, c2):
        top = self.__get_top(self)
        if not top: return
        w = top.winfo_containing(*c2)
        return top._nametowidget(w)
        

    def __get_top(self, wdg):
        p = wdg.winfo_parent()
        w = wdg._nametowidget(p)
        if w:
            if isinstance(w, tk.Tk):
                top = w
            else:
                top = self.__get_top(w)
        else:
            top = None
        return top

    def activate(self):
        self.active = not self.active
        

class WinDest(tk.Toplevel):
    def __init__(self, parent, *args, **kwargs):
        super().__init__(parent, *args, **kwargs)
        self.parent = parent
        lbl = tk.Label(self, text='Casella destinazione :')
        lbl.grid(row=0, column=0, padx=5, pady=5, sticky='w')
        self.e_test = DragEntry(self)
        self.e_test.grid(row=0, column=1, padx=5, pady=5, sticky='ew')
        self.e_test.activate()

    def message(self, msg):
        self.dida.configure(text=msg)
        self.update()
    
    
class WinTest(tk.Tk):
    def __init__(self):
        super().__init__()
        lbl = tk.Label(self, text='Casella sorgente :')
        lbl.grid(row=0, column=0, padx=5, pady=5, sticky='w')
        self.e_test = DragEntry(self)
        self.e_test.grid(row=0, column=1, padx=5, pady=5, sticky='ew')
        pn_bt = tk.Frame(self)
        pn_bt.grid(row=1, column=0, columnspan=2, padx=5, pady=5, sticky='ew')
        self.bt_active = tk.Button(pn_bt, text='Attiva', command=self._on_active)
        self.bt_active.grid(row=0, column=0, padx=(5,2), pady=5, sticky='ew')
        bt_close = tk.Button(pn_bt, text='Chiudi', command=self.destroy)
        bt_close.grid(row=0, column=1, padx=(2,5), pady=5, sticky='ew')
        pn_bt.grid_columnconfigure(0, weight=1, uniform='bt')
        pn_bt.grid_columnconfigure(1, weight=1, uniform='bt')
        self.grid_rowconfigure(0, weight=1)
        self.grid_columnconfigure(0, weight=1)

    def _on_active(self):
        self.e_test.activate()
        if self.e_test.active:
            self.bt_active.configure(text='Disattiva')
        else:
            self.bt_active.configure(text='Attiva')

    def message(self, msg):
        self.dida.configure(text=msg)
        self.update()


if __name__ == '__main__':
    app = WinTest()
    w = WinDest(app)
    app.mainloop()
    # Questo OK
